"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tokenize_1 = require("./lib/tokenize");
var remark = require("remark-parse");
function repolar() {
    remark.call(this, { commonmark: true });
    setBlockTokenizers(this.Parser);
    setInlineTokenizers(this.Parser);
}
exports.repolar = repolar;
function setBlockTokenizers(Parser) {
    var tokenizers = Parser.prototype.blockTokenizers;
    var methods = Parser.prototype.blockMethods;
    var toRemove = [
        "setextHeading",
        "definition",
        "footnote",
        "indentedCode",
        "table"
    ];
    for (var _i = 0, toRemove_1 = toRemove; _i < toRemove_1.length; _i++) {
        var tokenizer = toRemove_1[_i];
        delete tokenizers[tokenizer];
        if (methods.indexOf(tokenizer) >= 0)
            methods.splice(methods.indexOf(tokenizer), 1);
    }
    tokenizers.thematicBreak = tokenize_1.thematicBreak;
    tokenizers.list = tokenize_1.list;
    tokenizers.todos = tokenize_1.todos;
    methods.splice(methods.indexOf("list") + 1, 0, "todos");
}
exports.setBlockTokenizers = setBlockTokenizers;
function setInlineTokenizers(Parser) {
    var tokenizers = Parser.prototype.inlineTokenizers;
    var methods = Parser.prototype.inlineMethods;
    tokenizers.emphasis = tokenize_1.emphasis;
    tokenizers.strong = tokenize_1.strong;
    tokenizers.deletion = tokenize_1.strikethrough;
    tokenizers.highlight = tokenize_1.highlight;
    methods.splice(methods.indexOf("text") + 1, 0, "highlight");
    tokenizers.underline = tokenize_1.underline;
    methods.splice(methods.indexOf("deletion") + 1, 0, "underline");
    delete tokenizers.html;
    methods.splice(methods.indexOf("html"), 1);
}
exports.setInlineTokenizers = setInlineTokenizers;
exports.default = repolar;
