"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var locate_1 = __importDefault(require("./locate"));
var whitespace = require("is-whitespace-character");
var colon = ":";
var fence = "::";
function highlight(eat, value) {
    var self = this;
    var character = "";
    var previous = "";
    var preceding = "";
    var subvalue = "";
    var index;
    var length;
    var now;
    if (value.charAt(0) !== colon ||
        value.charAt(1) !== colon ||
        whitespace(value.charAt(2))) {
        return;
    }
    index = 1;
    length = value.length;
    now = eat.now();
    now.column += 2;
    now.offset += 2;
    while (++index < length) {
        character = value.charAt(index);
        if (character === colon &&
            previous === colon &&
            (!preceding || !whitespace(preceding))) {
            return eat(fence + subvalue + fence)({
                type: "highlight",
                data: {
                    hName: "mark"
                },
                children: self.tokenizeInline(subvalue, now)
            });
        }
        subvalue += previous;
        preceding = previous;
        previous = character;
    }
}
highlight.locator = locate_1.default;
exports.default = highlight;
