"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var _1 = __importDefault(require("./"));
describe("highlight", function () {
    var addMock, eatMock, self;
    beforeEach(function () {
        addMock = jest.fn(function () { });
        eatMock = jest.fn(function () { return addMock; });
        eatMock.now = jest.fn(function () { return ({ column: 0, offset: 0 }); });
        self = { tokenizeInline: jest.fn(function () { return "tokenizeInline"; }) };
    });
    afterEach(function () {
        addMock.mockReset();
        eatMock.mockReset();
        eatMock.now.mockReset();
        self.tokenizeInline.mockReset();
    });
    ["highlight", "complex-highlight", ""].forEach(function (valid) {
        test("should parse ::" + valid + "::", function () {
            _1.default.bind(self)(eatMock, "::" + valid + "::");
            expect(eatMock).lastCalledWith("::" + valid + "::");
            expect(addMock).lastCalledWith({
                type: "highlight",
                data: {
                    hName: "mark"
                },
                children: "tokenizeInline"
            });
            expect(self.tokenizeInline).lastCalledWith(valid, {
                column: 2,
                offset: 2
            });
        });
    });
    [":: highlight::", "-highlight::", "::highlight", "::highlight ::"].forEach(function (invalid) {
        test("should not parse invalid string: " + invalid, function () {
            _1.default.bind(self)(eatMock, invalid);
            expect(eatMock).not.toBeCalled();
            expect(addMock).not.toBeCalled();
        });
    });
});
