"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../../utils");
var lineFeed = "\n";
var bulletExpression = /^(\*|\d\.) (.*)/;
function list(eat, value) {
    var _this = this;
    var lines = value.split(lineFeed);
    var items = utils_1.takeWhile(lines, function (line) { return bulletExpression.test(line); });
    var children = utils_1.map(items, function (item) {
        return buildListItem(_this, item, eat.now());
    });
    var subvalue = items.join(lineFeed);
    if (subvalue.trim() === "")
        return;
    var match = items[0].match(bulletExpression);
    if (match === null)
        return;
    var index = match[1].charAt(0);
    var ordered = utils_1.isDecimal(index);
    return eat(subvalue)({
        type: "list",
        ordered: ordered,
        start: ordered && index !== "1" ? index : undefined,
        children: children
    });
}
exports.default = list;
function buildListItem(ctx, item, position) {
    var match = item.match(bulletExpression);
    if (match === null)
        return {};
    return {
        type: "listItem",
        children: ctx.tokenizeBlock(match[2], position)
    };
}
