"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var whitespace = require("is-whitespace-character");
var locate_1 = __importDefault(require("./locate"));
var marker = "-";
var fence = marker;
function strikethrough(eat, value) {
    var self = this;
    var character = "";
    var previous = "";
    var preceding = "";
    var subvalue = "";
    var index;
    var length;
    var now;
    if (value.charAt(0) !== marker || whitespace(value.charAt(1))) {
        return;
    }
    index = 0;
    length = value.length;
    now = eat.now();
    now.column += 1;
    now.offset += 1;
    while (++index < length) {
        var isLastCharacter = index + 1 === length;
        character = value.charAt(index);
        if (((whitespace(character) && previous === marker) ||
            (character === marker && isLastCharacter)) &&
            (!preceding || !whitespace(preceding))) {
            if (isLastCharacter)
                subvalue += previous;
            return eat(fence + subvalue + fence)({
                type: "delete",
                children: self.tokenizeInline(subvalue, now)
            });
        }
        subvalue += previous;
        preceding = previous;
        previous = character;
    }
    return;
}
strikethrough.locator = locate_1.default;
exports.default = strikethrough;
