"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var _1 = __importDefault(require("./"));
describe("thematicBreak", function () {
    var addMock, eatMock, self;
    beforeEach(function () {
        addMock = jest.fn(function () { });
        eatMock = jest.fn(function () { return addMock; });
    });
    afterEach(function () {
        addMock.mockReset();
        eatMock.mockReset();
    });
    test("should parse ---", function () {
        _1.default.bind(self)(eatMock, "---");
        expect(eatMock).lastCalledWith("---");
        expect(addMock).lastCalledWith({
            type: "thematicBreak"
        });
    });
    ["***", "___", "----", "- -- -", "- - -"].forEach(function (invalid) {
        test("should not parse invalid string: " + invalid, function () {
            _1.default.bind(self)(eatMock, invalid);
            expect(eatMock).not.toBeCalled();
            expect(addMock).not.toBeCalled();
        });
    });
});
