"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../../utils");
var lineFeed = "\n";
var todoFence = "- ";
var doneFence = "+ ";
function todos(eat, value) {
    var _this = this;
    var lines = value.split(lineFeed);
    var items = utils_1.takeWhile(lines, function (line) { return line.indexOf(todoFence) === 0 || line.indexOf(doneFence) === 0; });
    var children = utils_1.map(items, function (item) {
        return buildListItem(_this, item, eat.now());
    });
    var subvalue = items.join(lineFeed);
    if (subvalue.trim() === "")
        return;
    return eat(subvalue)({
        type: "list",
        ordered: false,
        children: children
    });
}
exports.default = todos;
function buildListItem(ctx, item, position) {
    var isChecked = item.indexOf(doneFence) >= 0;
    var fence = isChecked ? doneFence : todoFence;
    return {
        type: "listItem",
        checked: isChecked,
        children: ctx.tokenizeBlock(item.slice(item.indexOf(fence) + 2), position)
    };
}
