"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var locate_1 = __importDefault(require("./locate"));
var whitespace = require("is-whitespace-character");
var marker = "_";
function underline(eat, value) {
    var self = this;
    var index = 0;
    var character = value.charAt(index);
    var now;
    var queue;
    var length;
    var prev;
    if (character !== marker) {
        return;
    }
    length = value.length;
    index++;
    queue = "";
    character = "";
    if (whitespace(value.charAt(index))) {
        return;
    }
    while (index < length) {
        prev = character;
        character = value.charAt(index);
        if (character === marker && !whitespace(prev)) {
            character = value.charAt(++index);
            if (character !== marker) {
                if (!queue.trim() || prev === marker) {
                    return;
                }
                now = eat.now();
                now.column++;
                now.offset++;
                var children = self.tokenizeInline(queue, now);
                return eat(marker + queue + marker)({
                    type: "underline",
                    data: {
                        hName: "u"
                    },
                    children: children
                });
            }
            queue += marker;
        }
        queue += character;
        index++;
    }
}
underline.locator = locate_1.default;
exports.default = underline;
