"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var _1 = __importDefault(require("./"));
describe("underline", function () {
    var addMock, eatMock, self;
    beforeEach(function () {
        addMock = jest.fn(function () { });
        eatMock = jest.fn(function () { return addMock; });
        eatMock.now = jest.fn(function () { return ({ column: 0, offset: 0 }); });
        self = { tokenizeInline: jest.fn(function () { return "tokenizeInline"; }) };
    });
    afterEach(function () {
        addMock.mockReset();
        eatMock.mockReset();
        eatMock.now.mockReset();
        self.tokenizeInline.mockReset();
    });
    ["underline", "complex-underline"].forEach(function (valid) {
        test("should parse _" + valid + "_", function () {
            _1.default.bind(self)(eatMock, "_" + valid + "_");
            expect(eatMock).lastCalledWith("_" + valid + "_");
            expect(addMock).lastCalledWith({
                type: "underline",
                data: {
                    hName: "u"
                },
                children: "tokenizeInline"
            });
            expect(self.tokenizeInline).lastCalledWith(valid, {
                column: 1,
                offset: 1
            });
        });
    });
    ["_ underline_", "-underline_", "_underline", "__", "_underline _"].forEach(function (invalid) {
        test("should not parse invalid string: " + invalid, function () {
            _1.default.bind(self)(eatMock, invalid);
            expect(eatMock).not.toBeCalled();
            expect(addMock).not.toBeCalled();
        });
    });
});
