"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var filter_1 = __importDefault(require("./filter"));
describe("filter", function () {
    test("should return empty array when input is empty", function () {
        var mockCallback = jest.fn(function (x) { return x; });
        expect(filter_1.default([], mockCallback)).toEqual([]);
    });
    test("should return empty array when function returns always false", function () {
        var mockCallback = jest.fn(function () { return false; });
        expect(filter_1.default([0, 1, 2, 3, 4], mockCallback)).toEqual([]);
    });
    test("should return the same array when function returns always true", function () {
        var mockCallback = jest.fn(function () { return true; });
        expect(filter_1.default([0, 1, 2, 3, 4], mockCallback)).toEqual([0, 1, 2, 3, 4]);
    });
    test("should return a filtered array based on function logic", function () {
        var mockCallback = jest.fn(function (x) { return x > 2; });
        expect(filter_1.default([0, 1, 2, 3, 4], mockCallback)).toEqual([3, 4]);
    });
});
