"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var forEach_1 = __importDefault(require("./forEach"));
describe("forEach", function () {
    test("should call the callback for each item", function () {
        var mockCallback = jest.fn(function (x) { return x; });
        forEach_1.default([0, 1], mockCallback);
        expect(mockCallback.mock.calls.length).toBe(2);
    });
    test("should not call the callback if the array is empty", function () {
        var mockCallback = jest.fn(function (x) { return x; });
        forEach_1.default([], mockCallback);
        expect(mockCallback.mock.calls.length).toBe(0);
    });
});
