"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var map_1 = __importDefault(require("./map"));
describe("map", function () {
    test("should call the callback for each item", function () {
        var mockCallback = jest.fn(function (x) { return x; });
        map_1.default([0, 1], mockCallback);
        expect(mockCallback.mock.calls.length).toBe(2);
    });
    test("should not call the callback if the array is empty", function () {
        var mockCallback = jest.fn(function (x) { return x; });
        map_1.default([], mockCallback);
        expect(mockCallback.mock.calls.length).toBe(0);
    });
    test("should return an empty array if the array is empty", function () {
        var mockCallback = jest.fn(function (x) { return x; });
        expect(map_1.default([], mockCallback)).toEqual([]);
    });
    test("should return an array with the result of maps", function () {
        var mockCallback = jest.fn(function (x) { return x + 1; });
        expect(map_1.default([0, 1, 2, 3], mockCallback)).toEqual([1, 2, 3, 4]);
    });
});
