"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var reduce_1 = __importDefault(require("./reduce"));
describe("reduce", function () {
    test("should call the callback for each item", function () {
        var mockCallback = jest.fn(function (x, y) { return x + y; });
        reduce_1.default([0, 1], 0, mockCallback);
        expect(mockCallback.mock.calls.length).toBe(2);
    });
    test("should not call the callback if the array is empty", function () {
        var mockCallback = jest.fn(function (x, y) { return x + y; });
        reduce_1.default([], 0, mockCallback);
        expect(mockCallback.mock.calls.length).toBe(0);
    });
    test("should return the base if the array is empty", function () {
        var mockCallback = jest.fn(function (x, y) { return x + y; });
        expect(reduce_1.default([], 0, mockCallback)).toEqual(0);
    });
    test("should return the processed result from base and the array", function () {
        var mockCallback = jest.fn(function (x, y) { return x + y; });
        expect(reduce_1.default([1, 1, 1, 1], 0, mockCallback)).toEqual(4);
    });
});
