"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var repeat_1 = __importDefault(require("./repeat"));
describe(repeat_1.default, function () {
    test("should work with basic input", function () {
        expect(repeat_1.default(" ", 2)).toEqual("  ");
    });
    test("should work with zero length", function () {
        expect(repeat_1.default(" ", 0)).toEqual("");
    });
    test("should throw exception with -1 length", function () {
        expect(function () { return repeat_1.default(" ", -1); }).toThrowError(/^Invalid length$/);
    });
    test("should throw exception with negative length", function () {
        expect(function () { return repeat_1.default(" ", -2); }).toThrowError(/^Invalid length$/);
    });
    test("should throw exception with float numbers", function () {
        expect(function () { return repeat_1.default(" ", 1.4); }).toThrowError(/^Invalid length$/);
    });
});
