"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var read = fs_1.default.readFileSync;
var exists = fs_1.default.existsSync;
var list = fs_1.default.readdirSync;
var inputs = path_1.default.join(__dirname, "./input");
var trees = path_1.default.join(__dirname, "./tree");
var fixtures = {};
list(inputs).forEach(function (file) {
    var filename = path_1.default.basename(file, ".pb");
    var inputFile = path_1.default.join(inputs, filename + ".pb");
    var treeFile = path_1.default.join(trees, filename + ".json");
    var tree;
    if (exists(treeFile)) {
        tree = JSON.parse(read(treeFile).toString());
    }
    fixtures[filename] = {
        input: read(inputFile).toString(),
        tree: tree
    };
});
exports.default = fixtures;
